#ifndef CORE_TYPES_HPP
#define CORE_TYPES_HPP

#include <limits.h>
#include <stdint.h>

using i64 = int64_t;
using i32 = int32_t;
using i16 = int16_t;
using i8 = int8_t;
using u64 = uint64_t;
using u32 = uint32_t;
using u16 = uint16_t;
using u8 = uint8_t;
using c32 = char32_t;

// user customizable max container size
#ifndef CORE_INT_MAX
#define CORE_INT_MAX 65535
#endif
static_assert(CORE_INT_MAX < INT_MAX, "custom int max too large");

#endif